﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Markup;

namespace Matrix
{
    public class GridItemsControl : ItemsControl
    {
        // Methoden
        protected override DependencyObject GetContainerForItemOverride()
        {
            // Standardcontainer für Items erzeugen
            ContentPresenter Container = (ContentPresenter)base.GetContainerForItemOverride();
            if (ItemTemplate == null)
                return Container;

            // Wenn es ein ItemTemplate gibt, nach den Attached Properties suchen
            FrameworkElement Content = (FrameworkElement)ItemTemplate.LoadContent();
            BindingExpression RowBinding = Content.GetBindingExpression(Grid.RowProperty);
            BindingExpression ColumnBinding = Content.GetBindingExpression(Grid.ColumnProperty);
            
            // Wenn Row und Column angegeben sind, die Werte im Container setzen
            if (RowBinding != null)
                Container.SetBinding(Grid.RowProperty, RowBinding.ParentBinding);
            if (ColumnBinding != null)
                Container.SetBinding(Grid.ColumnProperty, ColumnBinding.ParentBinding);
            return Container;
        }
    }
}
